VERSION 4.00
Begin VB.Form frmMR2 
   Caption         =   "Fischertechnik : Mobile Robots, Modell MR2"
   ClientHeight    =   5460
   ClientLeft      =   600
   ClientTop       =   2355
   ClientWidth     =   7950
   Height          =   5865
   Icon            =   "MR2Main.frx":0000
   Left            =   540
   LinkTopic       =   "Form1"
   ScaleHeight     =   5460
   ScaleWidth      =   7950
   Top             =   2010
   Width           =   8070
   Begin VB.CommandButton cmdReset 
      Caption         =   "RESET"
      Enabled         =   0   'False
      Height          =   495
      Left            =   5880
      TabIndex        =   1
      Top             =   3960
      Width           =   1695
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "START"
      Height          =   495
      Left            =   5880
      TabIndex        =   0
      Top             =   4560
      Width           =   1695
   End
End
Attribute VB_Name = "frmMR2"
Attribute VB_Creatable = False
Attribute VB_Exposed = False


' -------------------------------------------------------------------------
'
' frmMR2(MR2Main.FRM)                                Ulrich Mller 03.02.98
'                                                    Dell XPS P90     VB5.0
' Fischertechnik : Mobile Robots Modell MR2
'
' -------------------------------------------------------------------------

Option Explicit

' --- Konstanten fr die Eingnge -----

Const cMotorLinks = 2, cMotorRechts = 1
Const cZhlerLinks = 2, cZhlerRechts = 1
Const cKontaktLinks = 4, cKontaktRechts = 3
Const cReset = 8

' --- Motorkonstanten ---

Const cRAus = 0, cRLinks = 1, cREin = cRLinks, cRRechts = 2, cRVor = cRLinks, cRZurck = cRRechts

' --- Konstanten fr die Analogeingnge ---

Const cAEX = 0, cAEY = 1

Dim ft As frmFishFace       ' --- um Kurzschreibeweise zu ermglichen


Private Sub Beenden()
    
    ft.CloseInterface
    End

End Sub


Private Sub Links(Schritte%)

' --- begrenzte (Schritte) Linkskurve ---

  ft.SetMotor cMotorRechts, cRVor
  ft.SetMotor cMotorLinks, cRZurck
  ft.WaitForChange cZhlerRechts, Schritte
  ft.SetMotor cMotorRechts, cRAus
  ft.SetMotor cMotorLinks, cRAus
  
End Sub


Private Sub MR2Action()

' --- Steuerung der Aktionen des Mobile Robots MR2 ---

Const cDelta = 10

  ft.Reset = False
  
  Do                                 ' --- Endlosfolge von Fahrbefehlen
                                     '     Ende durch Reset oder mit Gewalt :
                                     '     ENDE-Button : Beenden
    If ft.GetInput(cKontaktRechts) Then
      Rueckwaerts cDelta
      Links cDelta
    ElseIf ft.GetInput(cKontaktLinks) Then
      Rueckwaerts cDelta
      Rechts cDelta
    Else
      Vorwaerts
    End If
    ft.EmergencyStop cReset           ' --- Nothalt ber das Interface Panel
  Loop Until ft.ResetMotors(cReset)   ' --- Verlassen des Loops, wenn Reset
  
  cmdReset.Caption = "Fortsetzen"
  
End Sub

Private Sub MRtest()

  ft.SetMotor 4, cRAus
  ft.SetMotorList cRVor, cRZurck, , cREin
  
End Sub


Private Sub Rechts(Schritte%)

' --- begrenzte (Schritte) Rechtskurve ---

  ft.SetMotor cMotorRechts, cRZurck
  ft.SetMotor cMotorLinks, cRVor
  ft.WaitForChange cZhlerRechts, Schritte
  ft.SetMotor cMotorRechts, cRAus
  ft.SetMotor cMotorLinks, cRAus
  
End Sub


Private Sub Rueckwaerts(Schritte%)

' --- begrenztes (Schritte) Rckwrtsfahren ---

  ft.SetMotor cMotorRechts, cRZurck
  ft.SetMotor cMotorLinks, cRZurck
  ft.WaitForChange cZhlerRechts, Schritte
  ft.SetMotor cMotorRechts, cRAus
  ft.SetMotor cMotorLinks, cRAus
  
End Sub


Private Sub Vorwaerts()

' --- Unbedingtes Vorwrtsfahren von MR2 ---

  ft.SetMotor cMotorLinks, cRVor
  ft.SetMotor cMotorRechts, cRVor
  
End Sub


Private Sub cmdAction_Click()

' --- Start und Ende des Programmablaufs ---

  If cmdAction.Caption = "START" Then     ' --- Start ---
    ft.OpenInterface 1, True              ' --- COM1, mit Interface Panel
                                          '     DoEvents bei Interfacezugriff
    ft.Left = Me.Left + 600
    ft.Top = Me.Top + 500
    cmdAction.Caption = "ENDE"
    cmdReset.Enabled = True
    MR2Action                             ' --- Start der Ablaufschleife
  Else
    Beenden                               ' --- Ende des gesamten Programms
  End If
  
End Sub


Private Sub cmdReset_Click()

' --- RESET : Einleiten und Fortsetzen ---

  If cmdReset.Caption = "RESET" Then
    ft.Reset = True                  ' --- RESET an Interface melden
    cmdReset.Caption = "Fortsetzen"
    ft.ZOrder
  Else
    cmdReset.Caption = "RESET"
    ft.ZOrder
    MR2Action                        ' --- Start der Ablaufschleife
  End If
  
End Sub

Private Sub Form_Load()

  Set ft = frmFishFace
  
End Sub


